#ifndef _CEGOJDBCINFO_H_INCLUDED_
#define _CEGOJDBCINFO_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// CegoJDBCInfo.h
// --------------
// Cego JDBC information handler
//      
// Design and Implementation by Bjoern Lemke
//
// (C)opyright 2000-2013 Bjoern Lemke
//
// INTERFACE MODULE
//
// Class: CegoJDBCInfo
// 
// Description:
//
// Status: QG-2.6
//
///////////////////////////////////////////////////////////////////////////////

#include <lfcbase/Chain.h>
#include <lfcbase/ListT.h>

#include "CegoDistManager.h"
#include "CegoDbHandler.h"

class CegoJDBCInfo {

 public:

    CegoJDBCInfo(CegoDistManager* pTabMng, CegoDbHandler* pDbHandle);
    ~CegoJDBCInfo();

    void handleRequest(const ListT<Chain>& argList) const;
    
private:

    void checkAccess() const;

    CegoDistManager* _pTabMng;
    CegoDbHandler* _pDbHandle;
    
};

#endif




