#ifndef _CEGOORDERNODE_H_INCLUDED_
#define _CEGOORDERNODE_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// CegoOrderNode.h
// ---------------
// Cego order node class definition
//     
// Design and Implementation by Bjoern Lemke
//
// (C)opyright 2000-2013 Bjoern Lemke
//
// INTERFACE MODULE
//
// Class: CegoOrderNode
// 
// Description: 
//
// Status: QG-2.6
//
///////////////////////////////////////////////////////////////////////////////

#include <lfcbase/ListT.h>

// cego includes

#include "CegoField.h"

class CegoOrderNode {

 public:
    
    enum Ordering { ASC, DESC };
    
    CegoOrderNode();
    CegoOrderNode(ListT<CegoFieldValue>& key, ListT<CegoField>& tuple, ListT<Ordering>* pOrdering);
    ~CegoOrderNode();
    
    ListT<CegoFieldValue>& getKey();
    ListT<CegoField>& getTuple();

    CegoOrderNode& operator = ( const CegoOrderNode& n);
    bool operator == ( const CegoOrderNode& n);
    bool operator > ( const CegoOrderNode& n);
    bool operator < ( const CegoOrderNode& n);

 private:
    
    ListT<Ordering>* _pOrdering;
    ListT<CegoFieldValue> _key;
    ListT<CegoField> _tuple;
    
};

#endif
