#ifndef _CEGOPROCCURSORCREATESTMT_H_INCLUDED_
#define _CEGOPROCCURSORCREATESTMT_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// CegoProcCursorCreateStmt.h  
// --------------------------
// Cego procedure cursor create statement interface
//
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2013 Bjoern Lemke
//
// INTERFACE MODULE
//
// Class: CegoProcCursorCreateStmt
// 
// Description: 
//
// Status: QG-2.6
//
///////////////////////////////////////////////////////////////////////////////

// base includes
#include <lfcbase/Chain.h>

// cego includes
#include "CegoProcStmt.h"
#include "CegoExpr.h"
#include "CegoProcBlock.h"

class CegoProcCursorCreateStmt : public CegoProcStmt  {
    
public:
    
    CegoProcCursorCreateStmt(const Chain& name, CegoSelect *pSelect, CegoProcBlock *pBlock);

    ~CegoProcCursorCreateStmt();

    CegoException execute();

    Chain toChain(const Chain& indent) const;
    Chain dbFormat(CegoDatabaseFormater *pForm) const;
    
private:

    Chain _name;
    CegoSelect *_pSelect;

};

#endif














