#ifndef _CEGOPROCRETURNSTMT_H_INCLUDED_
#define _CEGOPROCRETURNSTMT_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// CegoProcReturnStmt.h  
// --------------------
// Cego procedure return statement implementation
//
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2013 Bjoern Lemke
//
// INTERFACE MODULE
//
// Class: CegoProcReturnStmt
// 
// Description: 
//
// Status: QG-2.6
//
///////////////////////////////////////////////////////////////////////////////

// base includes
#include <lfcbase/Chain.h>

// cego includes
#include "CegoProcStmt.h"
#include "CegoExpr.h"
#include "CegoProcBlock.h"

class CegoProcReturnStmt : public CegoProcStmt  {
    
public:
    
    CegoProcReturnStmt(CegoProcBlock *pBlock);
    CegoProcReturnStmt(CegoExpr *pExpr, CegoProcBlock *pBlock);

    ~CegoProcReturnStmt();

    CegoException execute();

    Chain toChain(const Chain& indent = Chain("")) const;
    Chain dbFormat(CegoDatabaseFormater *pForm) const;
    
private:

    CegoExpr *_pExpr;

};

#endif














